<Cabbage>

;color macros:
#define PLANT colour(76,130,180,155) outlinecolour(0,0,0,255) outlinethickness(2)
#define BASIC colour(56, 150, 180, 255) trackercolour(56,255,182,255) outlinecolour(17,37,37,155)
#define VBASIC colour("Gainsboro") trackercolour(56,255,182,255) outlinecolour(17,37,37,155)
#define FTABLES tablegridcolour("Silver") tablecolour:0(20,20,20,245) tablebackgroundcolour("Silver")
#define BUTTONS colour:0(79,79,79,105) colour:1("MediumTurquoise") colour:0("DarkSlateGrey")
#define MIDI colour:0(96,150,170,255) colour:1("Grey") value(0) latched(0)
#define MIDIX colour:0(96,150,170,255) colour:1("red") value(0) latched(0) 
#define FONT fontcolour("Gainsboro")

form caption("CombKey") size(860, 303), colour(76,130,180,155) pluginid("def1") style("legacy") fontcolour("Gainsboro")
button bounds(5, 218, 45, 20), channel("record"), text("Record"), colour("red"), fontcolour("white")
button bounds(5, 280, 45, 20), channel("play"), text("Play"), colour("green"), fontcolour("white")
combobox bounds(5,242,45,15) channel("recch") value(2) text("mono","stereo")
combobox bounds(5,261,45,15) channel("bit") value(1) text("16-bit","24-bit","32-bit")
keyboard bounds(55,218, 800, 80) value(21) 

;PLANTS
;Master Volume Control
image bounds(5,5,40,182) plant("Amp") $PLANT
{
label bounds(8,2,25,12) text("Amp") $FONT
vslider bounds(5,12,30,140) channel("MAmp") range(0.00, 1.5, 0.75, 1, 0.0001) $VBASIC
button bounds(2,160,27,15) text("Amp") channel("mapMamp") $MIDI
button bounds(29,160,9,15) text("") channel("mapMampX") $MIDIX
}

;Vibrato (LFO Modulation, controller 1)
image bounds(50,5,95,182) plant("Vib") $PLANT
{
label bounds(0,2,50,12) text("Vibrato") $FONT
button bounds(53,15,27,15) text("R Dev") channel("mapvibrand") $MIDI
button bounds(80,15,9,15) text("") channel("mapvibrandX") $MIDIX
rslider bounds(33,12,20,20) channel("vibrand") range(0, .99, 0.05, .5, 0.001) $BASIC
button bounds(8,163,27,15) text("Rate") channel("mapvibcps") $MIDI
button bounds(35,163,9,15) text("") channel("mapvibcpsX") $MIDIX
vslider bounds(13,50,25,110) channel("vibcps") range(0, 1, 0, .5, .01) $VBASIC
button bounds(53,163,27,15) text("Depth") channel("mapvibdepth") $MIDI
button bounds(80,163,9,15) text("") channel("mapvibdepthX") $MIDIX
vslider bounds(55,50,25,110) channel("vibdepth") range(0, 1, .5, .5, 0.01) $VBASIC
label bounds(3,25,25,10) text("max:") fontcolour(255,255,255,255)
nslider bounds(1,37,45,15) channel("vibcpsmax") range(0,2500,10,1,.01)
nslider bounds(45,37,45,15) channel("vibdepthmax") range(0,48,.75,1,.01)
}

;audio source to be filtered
image bounds(150,5,392,182) plant("Audio Input Select") $PLANT
{
label bounds(5,2,75,12) text("Audio Inputs") $FONT
image bounds(5,20,110,157) plant("Live") $PLANT
{
button bounds(30,5,50,18) channel("AudioIn") text("Mic/Line") latched(1) $BUTTONS
button bounds(36,32,27,15) text("Amp") channel("mapinamp") $MIDI
button bounds(63,32,9,15) text("") channel("mapinampX") $MIDIX
rslider bounds(27,49,55,45) channel("inamp") range(0,2.0,.5,1,.01) valuetextbox(1) textboxcolour("black") $BASIC
button bounds(15,106,27,15) text("L Pan") channel("maplivepan1") $MIDI
button bounds(42,106,9,15) text("") channel("maplivepan1X") $MIDIX
rslider bounds(15,122,30,30) channel("livepan1") range(0,1.0,0,1,.01) $BASIC
button bounds(60,106,27,15) text("R Pan") channel("maplivepan2") $MIDI
button bounds(87,106,9,15) text("") channel("maplivepan2X") $MIDIX
rslider bounds(60,122,30,30) channel("livepan2") range(0,1.0,1,1,.01) $BASIC
}
image bounds(120,20,170,157) plant("Soundfile") $PLANT
{
button bounds(60,5,70,18) channel("sfplay") text("Play SF") latched(1) $BUTTONS
button bounds(10,30,27,15) text("Amp") channel("mapsfamp") $MIDI
button bounds(37,30,9,15) text("") channel("mapsfampX") $MIDIX
rslider bounds(0,45,55,45) channel("sfamp") range(0,2.0,.5,.5,.001) valuetextbox(1) textboxcolour("black") $BASIC
filebutton bounds(60,30,33,18) channel("openFile") text("Load") $BUTTONS
button bounds(95,30,33,18) channel("sfloop") text("Loop") $BUTTONS
button bounds(130,30,33,18) channel("sfback") text("Back") $BUTTONS
button bounds(60,55,57,15) text("Playback Speed") channel("mapsfspeed") $MIDI
button bounds(117,55,9,15) text("") channel("mapsfspeedX") $MIDIX
hslider bounds(60,75,110,15) channel("sfspeed") range(.25,4,1,.5,.001) $VBASIC
nslider bounds(130,55,33,15) channel("sfspeed") range(.25,4,1,.5,.001) $FONT
soundfiler bounds(5,95,160,57) channel("beg","len") identchannel("SFfiler") colour(0,255,255,255) fontcolour("MediumTurquoise")
}
image bounds(295,20,92,157) plant("noise") $PLANT
{
button bounds(5, 5, 40, 18) channel("whiteon") text("White", "White") value(0) $BUTTONS
button bounds(15,25,27,15) text("Amp") channel("mapwhiteamp") $MIDI
button bounds(42,25,9,15) text("") channel("mapwhiteampX") $MIDIX
rslider bounds(55,17,30,30) channel("whiteamp") range(0,1.5,.1,.5,.0001) $BASIC

button bounds(5, 45, 40, 18) channel("pinkon") text("Pink", "Pink") value(0) $BUTTONS
button bounds(15,65,27,15) text("Amp") channel("mappinkamp") $MIDI
button bounds(42,65,9,15) text("") channel("mappinkampX") $MIDIX
rslider bounds(55,57,30,30) channel("pinkamp") range(0,1.5,.1,.5,.0001) $BASIC

button bounds(5, 85, 40, 18) channel("duston") text("Static", "Static") $BUTTONS
button bounds(5,105,27,15) text("Amp") channel("mapdustamp") $MIDI
button bounds(32,105,9,15) text("") channel("mapdustampX") $MIDIX
rslider bounds(10,122,30,30) channel("dustamp") range(0,1.5,.5,.5,.0001) $BASIC
button bounds(50,105,27,15) text("Rate") channel("mapdustrate") $MIDI
button bounds(77,105,9,15) text("") channel("mapdustrateX") $MIDIX
rslider bounds(52,122,30,30) channel("dustrate") range(1,250,50,1,1) $BASIC
}
}
image bounds(547,5,310,182) plant("keys") $PLANT
{
label bounds(5,2,105,12) text("Keyboard Control") $FONT
label bounds(5,23,45,11) text("Tuning") $FONT
combobox bounds(55,20,70,17) channel("MasterScale") text("Equal Temp", "1/8 Tone", "1/6 Tone", "1/4 Tone", "1/3 Tone",  "7 Tone", "8 Tone", "9 Tone", "10 Tone", "11 Tone", "11.6 Tone", "11.8 Tone", "12.2 Tone", "12.4 Tone", "13 Tone", "14 Tone", "15 Tone")
label bounds(5,40,60,11) text("Scale Start") $FONT
nslider bounds(65,40,45,15) channel("ScaleStart") range(20,108,60.00,1,.01)
label bounds(135,10,60,11) text("Pitch Bend") $FONT
label bounds(122,26,35,11) text("Up") $FONT
label bounds(130,42,35,11) text("Down") $FONT 
nslider bounds(165,25,45,15) channel("up1") range(-24,24,2,1,.01)
nslider bounds(165,40,45,15) channel("down1") range(-24,24,2,1,.01)
button bounds(225,8,80,15) channel("randkey") text("Random") value(0) $BUTTONS
label bounds(220,26,45,11) text("Range") $FONT
label bounds(220,42,45,11) text("(MIDI)") $FONT
nslider bounds(260,25,45,15) channel("range1") range(20,108,72,1,.01)
nslider bounds(260,40,45,15) channel("range2") range(20,108,48,1,.01)

;Random Note Generator
image bounds(5,60,300,41) plant("Random Note Generator") $PLANT
{
button bounds(5, 2, 110, 18) channel("RNGon") text("Random Note Generator", "Random Note Generator") value(0) $BUTTONS
label bounds(115,5,170,11) text("(one stream per each note played)") $FONT
combobox bounds(5, 21, 73, 17) channel("RNGmicro") text("Equal Temp", "Microtonal", "1/4 Tone", "1/8 Tone", "Whole Tone", "Minor 3rds", "Major 3rds", "4ths", "Tritones", "5ths", "10 Tone", "13 Tone", "15 Tone", "7 Tone", "8 Tone")
button bounds(79, 21, 34, 17) channel("RNGgliss") text("S&H", "Gliss") value(0) $BUTTONS
button bounds(117,21,28,15) text("Rate") channel("mapRNGrate") $MIDI
button bounds(144,21,9,15) text("") channel("mapRNGrateX") $MIDIX
button bounds(177,21,27,15) text("R Dev") channel("mapRNGraterand") $MIDI
button bounds(204,21,9,15) text("") channel("mapRNGraterandX") $MIDIX
button bounds(237,21,27,15) text("F Dev") channel("mapRNGdev") $MIDI
button bounds(264,21,9,15) text("") channel("mapRNGdevX") $MIDIX
rslider bounds(152,16,25,25) channel("RNGrate") range(0.01, 100, 3.3, .5, 0.01) $BASIC
rslider bounds(212,16,25,25) channel("RNGraterand") range(0, .95, 0, 1, 0.01) $BASIC
rslider bounds(272,16,25,25) channel("RNGdev") range(0, 60, 6, 1, 0.01) $BASIC
}
button bounds(10,104, 25, 17) text("A") channel("mapa") $MIDI
button bounds(35,104,10,17) text("") channel("mapaX") $MIDIX
button bounds(48,104, 25, 17) text("D") channel("mapd") $MIDI
button bounds(73,104,10,17) text("") channel("mapdX") $MIDIX
button bounds(86,104, 25, 17) text("S") channel("maps") $MIDI
button bounds(111,104,10,17) text("") channel("mapsX") $MIDIX
button bounds(124,104, 25, 17) text("R") channel("mapr") $MIDI
button bounds(149,104,10,17) text("") channel("maprX") $MIDIX
rslider bounds(0,123, 55, 45) channel("a") range(0.001, 5, 0.01, 0.75, 0.001) valuetextbox(1) textboxcolour("black") $BASIC
rslider bounds(38,123, 55, 45) channel("d") range(0.001, 5, 0.1, 0.75, 0.001) valuetextbox(1) textboxcolour("black") $BASIC 
rslider bounds(76,123, 55, 45) channel("s") range(0, 1, 0.85, 1, 0.01) valuetextbox(1) textboxcolour("black") $BASIC 
rslider bounds(114,123, 55, 45) channel("r") range(0.001, 5, 0.1, 0.75, 0.001) valuetextbox(1) textboxcolour("black") $BASIC
button bounds(163,104,30,17) text("Mix") channel("mapmix") $MIDI
button bounds(193,104,10,17) text("") channel("mapmixX") $MIDIX
rslider bounds(155,123,55,45) channel("mix") range(0,1,.35,1,.001) valuetextbox(1) textboxcolour("black") $BASIC
button bounds(207,104,40,17) text("Feedback") channel("maprev") $MIDI
button bounds(247,104,10,17) text("") channel("maprevX") $MIDIX
rslider bounds(205,123,55,45) channel("rev") range(.01,20.0,1,1,.01) valuetextbox(1) textboxcolour("black") $BASIC
button bounds(260,104,35,17) text("Spread") channel("mapspread") $MIDI
button bounds(295,104,10,17) text("") channel("mapspreadX") $MIDIX
rslider bounds(255,123,55,45) channel("spread") range(0,1,1,1,.01) valuetextbox(1) textboxcolour("black") $BASIC
}

;ribbon controller
image bounds(5,190,851,25) plant("ribbon") $PLANT
{
button bounds(5,5,40,15) text("Ribbon") channel("maprib") $MIDI
button bounds(46,5,9,15) text("") channel("mapribX") $MIDIX
hslider bounds(56,2,715,20) channel("ribbon") range(-36, 36, 0, 1, .0001) $VBASIC
nslider bounds(769,4,48,18) channel("ribbon") range(-36, 36, 0, 1, .001)
button bounds(817,4,30,17) channel("ribon") text("Off", "On") $BUTTONS
}

</Cabbage>
<CsoundSynthesizer>
<CsOptions>
-n -d -+rtmidi=NULL -M0 -m0d --midi-key=4 --midi-velocity-amp=5 --displays ;need this last command to enable displays
</CsOptions>
<CsInstruments>

;sr = 48000
ksmps = 50
nchnls = 2
0dbfs = 1

massign 0,10

ga1mix,ga2mix,gafinalL,gafinalR init 0
gichnls,giRready,gifilelen init 0
gSfilepath init ""
giTable init 500
gkTabLen init 2
gkRecordingActiveFlag,gkFileRecorded init 0

instr 1 ;source instrument use to control all audio sources fed into the comb filter as well as keyboard tuning attributes and vibrato

    kplay   chnget  "sfplay"
    gSfilepath chnget "openFile"
    kwhiteon chnget "whiteon"
    kpinkon chnget "pinkon"
    kduston chnget "duston"
    klive   chnget  "AudioIn"
    gksource  chnget  "mix"
    gkFX=1-gksource
    
    if changed(gSfilepath) == 1 then ;loads soundfile
        SIdentString sprintfk "file(\"%s\")", gSfilepath
        chnset SIdentString, "SFfiler"
        event   "i",3,0,0
    endif
        
    if changed(kplay) == 1 then ;turns on soundfile player
        if kplay=1 then 
        event "i",2,0,10000
        else
        turnoff2  2,0,.05
        endif
    endif
    
gkrecord	chnget	"record"
gkplay		chnget	"play"
kRecStart	trigger	gkrecord,0.5,0
  if kRecStart==1 && gkRecordingActiveFlag==0 then
    event	"i",400,0,-1
    gkRecordingActiveFlag	=	1
  endif
  kPlayStart	trigger	gkplay,0.5,0
  if kPlayStart==1 && gkFileRecorded==1 then
    event	"i",401,ksmps/sr,3600
  endif
  
;live audio input
klive port klive,.025
klivepan1 chnget "livepan1"
klivepan2 chnget "livepan2"
kingain chnget  "inamp"
alive1,alive2 ins
aliveL=((alive1*(1-klivepan1))+(alive2*(1-klivepan2)))*kingain*klive
aliveR=((alive1*klivepan1)+(alive2*klivepan2))*kingain*klive

kwhiteon port kwhiteon,.025 ;white noise
kwhiteamp chnget "whiteamp"
awhite rand kwhiteamp
awhite=awhite*kwhiteon

kpinkon port kpinkon,.025 ;pink noise
kpinkamp chnget "pinkamp"
apink pinkish kpinkamp
apink=apink*kpinkon

kduston port kduston,.025 ;static
kdustamp chnget "dustamp"
kdustrate chnget "dustrate"
adust dust kdustamp,kdustrate
adust=adust*kduston

ga1mix=ga1mix+aliveL+awhite+apink+adust
ga2mix=ga2mix+aliveR+awhite+apink+adust
endin

instr 2
kloop chnget "sfloop"
iloop=i(kloop)
kingain chnget "sfamp"
kEnv linsegr 0,.05,1,p3-.05,1,.1,0
ksfspeed chnget "sfspeed"
ksfspeed port ksfspeed,.05
ksfback chnget "sfback"
if ksfback==0 then
 if gichnls==1 then
    a1	diskin2	gSfilepath,ksfspeed,0,iloop
    a2=a1
 elseif gichnls==2 then
    a1,a2	diskin2	gSfilepath,ksfspeed,0,iloop
 endif
elseif ksfback==1 then
 if gichnls==1 then
    a1	diskin2	gSfilepath,-ksfspeed,gifilelen,iloop
    a2=a1
 elseif gichnls==2 then
    a1,a2	diskin2	gSfilepath,-ksfspeed,gifilelen,iloop
 endif
endif
ga1mix=ga1mix+(a1*kingain*kEnv)
ga2mix=ga2mix+(a2*kingain*kEnv)
endin

instr 3
giTable ftgen   1,0,0,1,gSfilepath,0,0,0 ;only need this table to be generated if using loscil
gichnls filenchnls  gSfilepath
gifilelen filelen gSfilepath
giReady=1 ;default if no string has been loaded yet
gkTabLen    init    ftlen(giTable)/gichnls
Smessage    sprintfk    "file(%s)", gSfilepath
chnset  Smessage,"SFfiler"
endin

instr 10 ;comb filter instrument, receives global audio from input sources
kspread chnget "spread"
ispread random -.5,.5
kspreadR=(ispread*kspread)+.5
kspreadL=1-kspreadR
kbend pchbend 0,1   ;default set at 1 semitones up and down, can modify for each oscillator (before converting MIDI to cps)
kribON chnget "ribon" ;ribbon controller for large pitch sweeps
kribbon chnget "ribbon"
kribbon port kribbon,.025
if kribON==1 then
goto ribbon
elseif kribON==0 then
kribbon=0
endif
ribbon:

;vibrato
kvibdepth chnget "vibdepth"
kvibdepthmax chnget "vibdepthmax"
kvibcps chnget "vibcps"
kvibcpsmax chnget "vibcpsmax"
kvibrand chnget "vibrand"
kvcps randomi kvibcpsmax-(kvibcpsmax*kvibrand),kvibcpsmax+(kvibcpsmax*kvibrand),kvibcpsmax
kvamp randomi kvibdepthmax-(kvibdepthmax*kvibrand),kvibdepthmax+(kvibdepthmax*kvibrand),kvcps
if kvibcps=0 then
kvib=0
else
kvib oscili kvamp*kvibdepth,kvcps*kvibcps,25
endif

;keyboard scaling/tuning
kss chnget "ScaleStart" ;MIDI pitch number from which any selected scale is calculated
kscale chnget "MasterScale"
if kscale == 1 then 
ksc=1 ;12 tone scale
goto RNG
elseif kscale == 2 then
ksc=.25 ;1/8 tones
goto RNG
elseif kscale == 3 then
ksc=.33333 ;1/6 tones
goto RNG
elseif kscale == 4 then
ksc=.5 ;1/4 tones
goto RNG
elseif kscale == 5 then
ksc=.66666 ;1/3 tones
goto RNG
elseif kscale == 6 then
ksc=1.714 ;7 tone octave
goto RNG
elseif kscale == 7 then
ksc=1.5 ;8 tone
goto RNG
elseif kscale == 8 then
ksc=1.3333 ;9 tone
goto RNG
elseif kscale == 9 then
ksc=1.2 ;10 tone
goto RNG
elseif kscale == 10 then
ksc=1.09091 ;11 tone
goto RNG
elseif kscale == 11 then
ksc=1.03448 ;11.6 tone
goto RNG
elseif kscale == 12 then
ksc=1.01695 ;11.8 tone
goto RNG
elseif kscale == 13 then
ksc=.98361 ;12.2 tone
goto RNG
elseif kscale == 14 then
ksc=.96774 ;12.4 tone
goto RNG
elseif kscale == 15 then
ksc=.9231 ;13 tone
goto RNG
elseif kscale == 16 then
ksc=.85714 ;14 tone
goto RNG
elseif kscale == 17 then
ksc=.8 ;15 tone
endif

;Random Note Stream Generation
RNG:
kRNGon chnget "RNGon"
kRNGcps chnget "RNGrate"
kRNGcpsrand chnget "RNGraterand"
kRNGdev chnget "RNGdev"
kmicro chnget "RNGmicro"
kgliss chnget "RNGgliss"

if kRNGon == 0 then
kRNGnote=0
goto sound
endif

krateA randh (kRNGcps*kRNGcpsrand),kRNGcps,2 ;seed > 1 = random seeded by the system clock
knoterate=kRNGcps+krateA   ;sets master rate
if kgliss == 1 then
kRNGnote randi kRNGdev,knoterate,2
else
kRNGnote randh kRNGdev,knoterate,2
endif

if kmicro == 1 then
kRNGnote=int(kRNGnote) ;12 tone scale
goto sound
elseif kmicro == 2 then ;all possible frequencies
goto sound
elseif kmicro == 3 then
kRNGnote=(int(kRNGnote*2)*.5) ;1/4 tones
goto sound
elseif kmicro == 4 then
kRNGnote=(int(kRNGnote*4)*.25) ;1/8 tones
goto sound
elseif kmicro == 5 then
kRNGnote=int(kRNGnote)*2 ;Whole tone
goto sound
elseif kmicro == 6 then
kRNGnote=int(kRNGnote)*3 ;minor 3rds
goto sound
elseif kmicro == 7 then
kRNGnote=int(kRNGnote)*4 ;major 3rds
goto sound
elseif kmicro == 8 then
kRNGnote=int(kRNGnote)*5 ;4ths
goto sound
elseif kmicro == 9 then
kRNGnote=int(kRNGnote)*6 ;tritones
goto sound
elseif kmicro == 10 then
kRNGnote=int(kRNGnote)*7 ;5ths
goto sound
elseif kmicro == 11 then
kRNGnote=int(kRNGnote)*1.2 ;10 tone scale
goto sound
elseif kmicro == 12 then
kRNGnote=int(kRNGnote)*.923 ;13 tone scale
goto sound
elseif kmicro == 13 then
kRNGnote=int(kRNGnote)*.8 ;15 tone scale
goto sound
elseif kmicro == 14 then
kRNGnote=int(kRNGnote)*1.715 ;7 tone scale
goto sound
elseif kmicro == 15 then
kRNGnote=int(kRNGnote)*1.5 ;8 tone scale
endif

sound:
;calculate bend
kup1 chnget "up1"
kdown1 chnget "down1"
if kbend >= 0 then 
kbend1=kbend*kup1
else
kbend1=kbend*kdown1
endif
kbend1 port kbend1,.025

;;IF I WANT TO HAVE A RANDOM PITCH TIGGERED BY MIDI KEYS THEN REPLACE P4 IN THE FOLLOWING CODE
;calculate delay
krandkey chnget "randkey"
if krandkey=0 goto KEYCONTROL
krange1 chnget "range1"
krange2 chnget "range2"
if krange1>krange2 then
krlow=krange2
krhigh=krange1
else
krlow=krange1
krhigh=krange2
endif
irand random i(krlow),i(krhigh)
kdel=1/(cpsmidinn(irand+kbend1+kRNGnote+kvib+kribbon))
goto RANDKEY

KEYCONTROL:
kdel=1/(cpsmidinn(kss+((p4-kss)*ksc)+kbend1+kRNGnote+kvib+kribbon))

RANDKEY:
krevtime chnget "rev"
krevtime port krevtime,.1
iattack chnget "a"
idecay chnget "d"
isustain chnget "s"
irelease chnget "r"

;;IF I WANT TO ADD OPTION FOR RESON FILTER THEN INSERT THAT BELOW
;idel=1/cpsmidinn(p4)
kEnv madsr iattack,.01,1.0,i(krevtime)
ksourceEnv madsr iattack,idecay,isustain,irelease
acombL vcomb ga1mix*ksourceEnv*kspreadL,krevtime,kdel,100
acombR vcomb ga2mix*ksourceEnv*kspreadR,krevtime,kdel,100
acombL=acombL*gkFX*kEnv
acombR=acombR*gkFX*kEnv
acombL dcblock acombL
acombR dcblock acombR
;outs acombL*gkFX,acombR*gkFX
gafinalL=(acombL*gkFX)+(ga1mix*gksource)+gafinalL
gafinalR=(acombR*gkFX)+(ga2mix*gksource)+gafinalR
endin

instr 100   ;instrument to monitor MIDI controller numbers, creates global MIDI outputs that are evaluated by instr 110-300         
            ;also controls popup fpr latched LowPass
gkstatus,gkchan,gkdata1,gkdata2 midiin
if changed(gkstatus)==1 then  
    if gkstatus==176 then
    chnset gkdata1,"CtrlNum" ;displays current controller number in GUI
    endif
endif
kTrig chnget "LLPset"
if changed:k(kTrig)==1 then
	chnset "visible(1)", "popupLLP"
endif
endin

instr 101 ;master volume MIDI mapping
kmapMamp chnget "mapMamp"
kmapMampX chnget "mapMampX"
if changed(gkstatus)==1 then
  if gkstatus==176 then
    if kmapMamp==1 then
      turnoff2 102,2,0
      event "i",102,0,999999999
    endif
  endif
endif
if kmapMampX==1 then
  turnoff2 102,2,0
endif
endin

instr 102
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1.5000 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "MAmp"
endin

instr 103 ;pitch ribbon MIDI mapping
kmaprib chnget "maprib"
kmapribX chnget "mapribX"
if changed(gkstatus)==1 then
  if gkstatus==176 then
    if kmaprib==1 then
      turnoff2 104,2,0
      event "i",104,0,999999999
    endif
  endif
endif
if kmapribX==1 then
  turnoff2 104,2,0
endif
endin

instr 104
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-36,36 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "ribbon"
endin

instr 105 ;Live Audio Amp MIDI mapping
kmapliveamp chnget "mapinamp"
kmapliveampX chnget "mapinampX"
kmaplivepan1 chnget "maplivepan1"
kmaplivepan2 chnget "maplivepan2"
kmaplivepan1X chnget "maplivepan1X"
kmaplivepan2X chnget "maplivepan2X"
if changed(gkstatus)==1 then
  if gkstatus==176 then
    if kmapliveamp==1 then
      turnoff2 106,2,0
      event "i",106,0,999999
    elseif kmaplivepan1==1 then
      turnoff2 107,2,0
      event "i",107,0,999999
    elseif kmaplivepan2==1 then
      turnoff2 108,2,0
      event "i",108,0,999999
    endif
  endif
endif
if kmapliveampX==1 then
  turnoff2 106,2,0
elseif kmaplivepan1X==1 then
  turnoff2 107,2,0
elseif kmaplivepan2X==1 then
  turnoff2 108,2,0
endif
endin

instr 106
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,2.5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "inamp"
endin

instr 107
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "livepan1"
endin

instr 108
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "livepan2"
endin

instr 110 ;sf and pitch ribbon MIDI mapping
kmaprib chnget "mapsfamp"
kmapribX chnget "mapsfampX"
kmapspeed chnget "mapsfspeed"
kmapspeedX chnget "mapsfspeedX"
kmaprib chnget "maprib"
kmapribX chnget "mapribX"
if changed(gkstatus)==1 then
  if gkstatus==176 then
    if kmaprib==1 then
      turnoff2 111,2,0
      event "i",111,0,999999
    elseif kmapspeed==1 then
      turnoff2 112,2,0
      event "i",112,0,999999
    elseif kmapspeed==1 then
      turnoff2 113,2,0
      event "i",113,0,999999
    endif
  endif
endif
if kmapribX==1 then
  turnoff2 111,2,0
elseif kmapspeedX==1 then
  turnoff2 112,2,0
endif
endin

instr 111
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,2 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "sfamp"
endin

instr 112
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.25,4 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "sfspeed"
endin

instr 113
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-36,36 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "ribbon"
endin

instr 120 ;noise MIDI mapping
kmapwhiteamp chnget "mapwhiteamp"
kmapwhiteampX chnget "mapwhiteampX"
kmappinkamp chnget "mappinkamp"
kmappinkampX chnget "mappinkampX"
kmapdustamp chnget "mapdustamp"
kmapdustampX chnget "mapdustampX"
kmapdustrate chnget "mapdustrate"
kmapdustrateX chnget "mapdustrateX"
if changed(gkstatus)==1 then
  if gkstatus==176 then
    if kmapwhiteamp==1 then
      turnoff2 121,2,0
      event "i",121,0,999999
    elseif kmappinkamp==1 then
      turnoff2 122,2,0
      event "i",122,0,999999
    elseif kmapdustamp==1 then
      turnoff2 123,2,0
      event "i",123,0,999999
    elseif kmapdustrate==1 then
      turnoff2 124,2,0
      event "i",124,0,999999
    endif
  endif
endif
if kmapwhiteampX==1 then
  turnoff2 121,2,0
elseif kmappinkampX==1 then
  turnoff2 122,2,0
elseif kmapdustampX==1 then
  turnoff2 123,2,0
elseif kmapdustrateX==1 then
  turnoff2 124,2,0
endif
endin

instr 121
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1.5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "whiteamp"
endin

instr 122
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1.5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "pinkamp"
endin

instr 123
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1.5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "dustamp"
endin

instr 124
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,1,250 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "dustrate"
endin

instr 130 ;pitch ribbon MIDI mapping
kmapa chnget "mapa"
kmapaX chnget "mapaX"
kmapd chnget "mapd"
kmapdX chnget "mapdX"
kmaps chnget "maps"
kmapsX chnget "mapsX"
kmapr chnget "mapr"
kmaprX chnget "maprX"
kmapmix chnget "mapmix"
kmapmixX chnget "mapmixX"
kmaprev chnget "maprev"
kmaprevX chnget "maprevX"
kmapspread chnget "mapspread"
kmapspreadX chnget "mapspreadX"
if changed(gkstatus)==1 then
  if gkstatus==176 then
    if kmapa==1 then
      turnoff2 131,2,0
      event "i",131,0,999999
    elseif kmapd==1 then
      turnoff2 132,2,0
      event "i",132,0,999999
    elseif kmaps==1 then
      turnoff2 133,2,0
      event "i",133,0,999999
    elseif kmapr==1 then
      turnoff2 134,2,0
      event "i",134,0,999999
    elseif kmapmix==1 then
      turnoff2 132,2,0
      event "i",135,0,999999
    elseif kmaprev==1 then
      turnoff2 133,2,0
      event "i",136,0,999999
    elseif kmapspread==1 then
      turnoff2 134,2,0
      event "i",137,0,999999
    endif
  endif
endif
if kmapaX==1 then
  turnoff2 131,2,0
elseif kmapdX==1 then
  turnoff2 132,2,0
elseif kmapsX==1 then
  turnoff2 133,2,0
elseif kmaprX==1 then
  turnoff2 134,2,0
elseif kmapmixX==1 then
  turnoff2 135,2,0
elseif kmaprevX==1 then
  turnoff2 136,2,0
elseif kmapspreadX==1 then
  turnoff2 137,2,0
endif
endin

instr 131
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.001,5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "a"
endin

instr 132
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.001,5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "d"
endin

instr 133
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "s"
endin

instr 134
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.001,5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "r"
endin

instr 135
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "mix"
endin

instr 136
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,20 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "rev"
endin

instr 137
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "spread"
endin

instr 200
;receive MIDI mapping buttons for RNG
kmapRNGrate chnget "mapRNGrate"
kmapRNGrateX chnget "mapRNGrateX"
kmapRNGraterand chnget "mapRNGraterand"
kmapRNGraterandX chnget "mapRNGraterandX"
kmapRNGdev chnget "mapRNGdev"
kmapRNGdevX chnget "mapRNGdevX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapRNGrate == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 201, 2, 0
            event "i", 201, 0, 999999
        elseif kmapRNGraterand == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 202, 2, 0
            event "i", 202, 0, 999999
        elseif kmapRNGdev == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 204, 2, 0
            event "i", 204, 0, 999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapRNGrateX == 1 then
    turnoff2 201, 2, 0
elseif kmapRNGraterandX == 1 then
    turnoff2 202, 2, 0
elseif kmapRNGdevX == 1 then
    turnoff2 204, 2, 0
endif
endin

instr 201 ;MIDI mapping for RNG
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "RNGrate"
endin

instr 202 ;MIDI mapping for RNG
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "RNGraterand"
endin

instr 204 ;MIDI mapping for RNG
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,60 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "RNGdev"
endin

instr 220
;receive MIDI mapping buttons for Vibrato
kmapvibrand chnget "mapvibrand"
kmapvibrandX chnget "mapvibrandX"
kmapvibcps chnget "mapvibcps"
kmapvibcpsX chnget "mapvibcpsX"
kmapvibdepth chnget "mapvibdepth"
kmapvibdepthX chnget "mapvibdepthX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapvibrand == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 221, 2, 0
            event "i", 221, 0, 999999999
        elseif kmapvibcps == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 222, 2, 0
            event "i", 222, 0, 999999999
        elseif kmapvibdepth == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 223, 2, 0
            event "i", 223, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapvibrandX == 1 then
    turnoff2 221, 2, 0
elseif kmapvibcpsX == 1 then
    turnoff2 222, 2, 0
elseif kmapvibdepthX == 1 then
    turnoff2 223, 2, 0
endif
endin

instr 221 ;MIDI mapping for Vibrato
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "vibrand"
endin

instr 222 ;MIDI mapping for Vibrato
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "vibcps"
endin

instr 223 ;MIDI mapping for Vibrato
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "vibdepth"
endin

instr 400	; record file
irecch chnget "recch"
ibit chnget "bit"
 print	p1
 if gkplay==1 then
  chnset	k(0),"record"
  turnoff
 endif
 gkFileRecorded		init	1
 itim     date
 Stim     dates     itim
 itim     date
 Stim     dates     itim
 Syear    strsub    Stim, 20, 24
 Smonth   strsub    Stim, 4, 7
 Sday     strsub    Stim, 8, 10
 iday     strtod    Sday
 Shor     strsub    Stim, 11, 13
 Smin     strsub    Stim, 14, 16
 Ssec     strsub    Stim, 17, 19
 Sfilnam  sprintf  "%s_%s_%02d_%s_%s_%s.wav", Syear, Smonth, iday, Shor,Smin, Ssec
 gSname   sprintf "CombKey_%s", Sfilnam
 if gkrecord==1 then			; record
   if ibit=1 then
   imode=4
  elseif ibit=2 then
   imode=8
  elseif ibit=3 then
   imode=5
  endif
  if irecch=1 then
   fout gSname,imode,(gafinalL+gafinalL)*.7
  elseif irecch=2 then
   fout gSname,imode,gafinalL,gafinalR
  endif
 endif
 gkRecordingActiveFlag	=	1 - release()
endin

instr	401	; play file
 if gkplay==0 then
  turnoff
 endif 
   aL,aR	diskin2	gSname,1
  	outs	aL,aR
 iFileLen	filelen	gSname
 p3	=	iFileLen
 xtratim	0.1 
 krelease	release
 	chnset	1-krelease,"play"
endin

instr 500   ;global outs and clear global audio
outs gafinalL,gafinalR
clear   ga1mix,ga2mix,gafinalL,gafinalR ;,gaLeft,gaRight,gacombL,gacombR
endin

</CsInstruments>
<CsScore>
f25 0 8193 10 1 ;sine for vibrato
i1 0 9999999
i100 0 9999999
i101 0 9999999
i103 0 9999999
i105 0 9999999
i110 0 9999999
i120 0 9999999
i130 0 9999999
i200 0 9999999
i220 0 9999999
i500 0 9999999

</CsScore>
</CsoundSynthesizer>
